#include "qdata5f2.h"

#include <math.h>

QData5F2::QData5F2(const QwtDoubleInterval &azI,size_t sz) :
    azInt(azI), d_size(sz)
{
}

size_t QData5F2::size() const {
    return d_size;
}

double QData5F2::x(size_t i) const
{
    double h = azInt.width() / (d_size-1);
    return azInt.minValue() + i*h;
}

double QData5F2::y(size_t i) const
{
    const double fi0 = 30;  //  
    const double d = 6;     //  
    const double kd = 2.7831 / d;
    double xx = x(i) - fi0;
    //     -180 - +180
    while (xx >= 180) xx -= 360;
    double ro = 1;   //  
    if (xx != 0) ro = qAbs(sin(kd*xx)/(kd*xx));
    return ro;
}

QwtData *QData5F2::copy() const {
    return new QData5F2(azInt,d_size);
}
