#include "qdataf1.h"

QDataF1::QDataF1(const QwtInterval &azI,size_t sz) :
    azInt(azI), d_size(sz)
{
}

size_t QDataF1::size() const {
    return d_size;
}

QwtPointPolar QDataF1::sample( size_t i) const
{
    const double d = 40;    //  
    const double kd = 2.7831 / d;
    double h = azInt.width() / (d_size-1);
    double fi = azInt.minValue() + i*h;
    double xx = fi;
    //     -180 - +180
    while (xx >= 180) xx -= 360;
    double ro = 1;   //  
    if (xx != 0) ro = qAbs(sin(kd*xx)/(kd*xx));
    return QwtPointPolar(fi,ro);
}

QRectF QDataF1::boundingRect() const
{
    if (d_boundingRect.width() < 0)
        d_boundingRect = qwtBoundingRect(*this);
    return d_boundingRect;
}
